# Change values of matrix and array as per your module names

matrix = ["Acc","o","d","a"]
array = ["accurate","approx_o4","approx_d4","approx_a4"]
for i1 in range(0,4):
	for i2 in range (0,4):
		for i3 in range(0,4):
			for i4 in range(0,4):
				s=matrix[i1]+matrix[i2]+matrix[i3]+matrix[i4]
				with open("mult_mod_8_%s.vhd" % s, "w") as fh1:
					fh1.write("library IEEE;\n")
					fh1.write("use IEEE.STD_LOGIC_1164.ALL;\n")
					fh1.write("use IEEE.NUMERIC_STD.ALL;\n")
					fh1.write("use IEEE.STD_LOGIC_UNSIGNED.ALL;\n")
					fh1.write("library UNISIM;\n")
					fh1.write("use UNISIM.VComponents.all;\n")
					fh1.write("\n")
					fh1.write("entity mult_mod_8_" + s +" is\n")
					fh1.write("Port (\n")
					fh1.write("A : in STD_LOGIC_VECTOR (7 downto 0);\n")
					fh1.write("B : in STD_LOGIC_VECTOR (7 downto 0);\n")
					fh1.write("PROD : out STD_LOGIC_VECTOR (15 downto 0));\n")
					fh1.write("end mult_mod_8_" + s + ";\n")
					fh1.write("\n")
					fh1.write("architecture Behavioral of mult_mod_8_" + s + " is\n")
					fh1.write("\n")
					fh1.write("component mult_accurate is\n")
					fh1.write("		Port ( a : in  STD_LOGIC_VECTOR (3 downto 0);\n")
					fh1.write("			   b : in  STD_LOGIC_VECTOR (3 downto 0);\n")
					fh1.write("			   prod : out  STD_LOGIC_VECTOR (7 downto 0));\n")
					fh1.write("end component;\n")
					fh1.write("\n")
					fh1.write("component mult_approx_o4 is\n")
					fh1.write("		Port ( a : in  STD_LOGIC_VECTOR (3 downto 0);\n")
					fh1.write("			   b : in  STD_LOGIC_VECTOR (3 downto 0);\n")
					fh1.write("			   prod : out  STD_LOGIC_VECTOR (7 downto 0));\n")
					fh1.write("end component;\n")
					fh1.write("\n")
					fh1.write("component mult_approx_d4 is\n")
					fh1.write("		Port ( a : in  STD_LOGIC_VECTOR (3 downto 0);\n")
					fh1.write("			   b : in  STD_LOGIC_VECTOR (3 downto 0);\n")
					fh1.write("			   prod : out  STD_LOGIC_VECTOR (7 downto 0));\n")
					fh1.write("end component;\n")
					fh1.write("\n")
					fh1.write("component mult_approx_a4 is\n")
					fh1.write("		Port ( a : in  STD_LOGIC_VECTOR (3 downto 0);\n")
					fh1.write("			   b : in  STD_LOGIC_VECTOR (3 downto 0);\n")
					fh1.write("			   prod : out  STD_LOGIC_VECTOR (7 downto 0));\n")
					fh1.write("end component;\n")
					fh1.write("\n")
					fh1.write("signal prod1 : STD_LOGIC_VECTOR (7 downto 0);\n")
					fh1.write("signal prod2 : STD_LOGIC_VECTOR (7 downto 0);\n")
					fh1.write("signal prod3 : STD_LOGIC_VECTOR (7 downto 0);\n")
					fh1.write("signal prod4 : STD_LOGIC_VECTOR (7 downto 0);\n")
					fh1.write("signal gen : STD_LOGIC_VECTOR (7 downto 0);\n")
					fh1.write("signal prop : STD_LOGIC_VECTOR (7 downto 0);\n")
					fh1.write("signal carries : STD_LOGIC_VECTOR (7 downto 0);\n")
					fh1.write("signal output : STD_LOGIC_VECTOR (7 downto 0);\n")
					fh1.write("signal input_carry : STD_LOGIC_VECTOR (7 downto 0);\n")
					fh1.write("signal chain : STD_LOGIC_VECTOR (7 downto 0);\n")
					fh1.write("signal temp : STD_LOGIC;\n")
					fh1.write("\n")
					fh1.write("begin\n")
					#	Instantiate the four N/2 multiplier modules
					fh1.write("inst1_mult: mult_" + array[i1] + " port map(\n")
					fh1.write("a => A(3 downto 0),\n")
					fh1.write("b => B(3 downto 0),\n")
					fh1.write("prod => prod1\n")
					fh1.write(");\n")
					fh1.write("\n")
					fh1.write("inst2_mult: mult_" + array[i2] + " port map(\n")
					fh1.write("a => A(7 downto 4),\n")
					fh1.write("b => B(3 downto 0),\n")
					fh1.write("prod => prod2\n")
					fh1.write(");\n")
					fh1.write("\n")
					fh1.write("inst3_mult: mult_" + array[i3] + " port map(\n")
					fh1.write("a => A(3 downto 0),\n")
					fh1.write("b => B(7 downto 4),\n")
					fh1.write("prod => prod3\n")
					fh1.write(");\n")
					fh1.write("\n")
					fh1.write("inst4_mult: mult_" + array[i4] + " port map(\n")
					fh1.write("a => A(7 downto 4),\n")
					fh1.write("b => B(7 downto 4),\n")
					fh1.write("prod => prod4\n")
					fh1.write(");\n")
					fh1.write("\n")
					fh1.write("PROD(3 downto 0) <= prod1(3 downto 0);\n")
					#	Following is code for approximate adder which accumulates 3 rows without carry propagation
					fh1.write("\n")

					#	Functionality of INIT value 17E8E817E81717E8 is :
					#	We compute the carry from I0+I1+I2 and add it to the result of I3+I4+I5
					#	Output O6 is the LSB of this result (Ignoring carry out)
					#	Boolean expression : O6 = I3 xor I4 xor I5 xor (I0.I1 + I1.I2 + I0.I2)

					fh1.write("lut_inst0: lut6_2\n")
					fh1.write("		generic map(INIT => X\"17E8E817E81717E8\")\n")
					fh1.write("		port map(\n")
					fh1.write("		I0 => prod1(4),\n")
					fh1.write("		I1 => prod2(0),\n")
					fh1.write("		I2 => prod3(0),\n")
					fh1.write("		I3 => prod1(5),\n")
					fh1.write("		I4 => prod2(1),\n")
					fh1.write("		I5 => prod3(1),\n")
					fh1.write("		O5 => gen(0),\n")
					fh1.write("		O6 => prop(0)\n")
					fh1.write("		);\n")
					fh1.write("\n")
					fh1.write("PROD(4) <= prop(0);\n")
					fh1.write("PROD(5) <= prop(0);\n")
					fh1.write("\n")
					fh1.write("lut_inst11: lut6_2\n")
					fh1.write("		generic map(INIT => X\"17E8E817E81717E8\")\n")
					fh1.write("		port map(\n")
					fh1.write("		I0 => prod1(5),\n")
					fh1.write("		I1 => prod2(1),\n")
					fh1.write("		I2 => prod3(1),\n")
					fh1.write("		I3 => prod1(6),\n")
					fh1.write("		I4 => prod2(2),\n")
					fh1.write("		I5 => prod3(2),\n")
					fh1.write("		--O5 => gen(1),\n")
					fh1.write("		O6 => PROD(6)\n")
					fh1.write("		);\n")
					fh1.write("\n")
					fh1.write("lut_inst1: lut6_2\n")
					fh1.write("		generic map(INIT => X\"17E8E817E81717E8\")\n")
					fh1.write("		port map(\n")
					fh1.write("		I0 => prod1(6),\n")
					fh1.write("		I1 => prod2(2),\n")
					fh1.write("		I2 => prod3(2),\n")
					fh1.write("		I3 => prod1(7),\n")
					fh1.write("		I4 => prod2(3),\n")
					fh1.write("		I5 => prod3(3),\n")
					fh1.write("		O5 => gen(1),\n")
					fh1.write("		O6 => prop(1)\n")
					fh1.write("		);\n")
					fh1.write("\n")
					fh1.write("--PROD(6) <= prop(1);\n")
					fh1.write("PROD(7) <= prop(1);\n")
					fh1.write("\n")
					fh1.write("lut_inst21: lut6_2\n")
					fh1.write("		generic map(INIT => X\"17E8E817E81717E8\")\n")
					fh1.write("		port map(\n")
					fh1.write("		I0 => prod1(7),\n")
					fh1.write("		I1 => prod2(3),\n")
					fh1.write("		I2 => prod3(3),\n")
					fh1.write("		I3 => prod2(4),\n")
					fh1.write("		I4 => prod3(4),\n")
					fh1.write("		I5 => prod4(0),\n")
					fh1.write("		--O5 => gen(2),\n")
					fh1.write("		O6 => PROD(8)\n")
					fh1.write("		);\n")
					fh1.write("\n")
					#fh1.write("PROD(4) <= prop(0);\n")
					#fh1.write("PROD(5) <= prop(0);\n")
					#fh1.write("\n")
					fh1.write("lut_inst2: lut6_2\n")
					fh1.write("		generic map(INIT => X\"17E8E817E81717E8\")\n")
					fh1.write("		port map(\n")
					fh1.write("		I0 => prod2(4),\n")
					fh1.write("		I1 => prod3(4),\n")
					fh1.write("		I2 => prod4(0),\n")
					fh1.write("		I3 => prod2(5),\n")
					fh1.write("		I4 => prod3(5),\n")
					fh1.write("		I5 => prod4(1),\n")
					fh1.write("		O5 => gen(2),\n")
					fh1.write("		O6 => prop(2)\n")
					fh1.write("		);\n")
					fh1.write("\n")
					fh1.write("--PROD(8) <= prop(2);\n")
					fh1.write("PROD(9) <= prop(2);\n")
					fh1.write("\n")
					fh1.write("lut_inst31: lut6_2\n")
					fh1.write("		generic map(INIT => X\"17E8E817E81717E8\")\n")
					fh1.write("		port map(\n")
					fh1.write("		I0 => prod2(5),\n")
					fh1.write("		I1 => prod3(5),\n")
					fh1.write("		I2 => prod4(1),\n")
					fh1.write("		I3 => prod2(6),\n")
					fh1.write("		I4 => prod3(6),\n")
					fh1.write("		I5 => prod4(2),\n")
					fh1.write("		--O5 => gen(3),\n")
					fh1.write("		O6 => PROD(10)\n")
					fh1.write("		);\n")
					fh1.write("\n")
					#fh1.write("PROD(4) <= prop(0);\n")
					#fh1.write("PROD(5) <= prop(0);\n")
					#fh1.write("\n")
					fh1.write("lut_inst3: lut6_2\n")
					fh1.write("		generic map(INIT => X\"17E8E817E81717E8\")\n")
					fh1.write("		port map(\n")
					fh1.write("		I0 => prod2(6),\n")
					fh1.write("		I1 => prod3(6),\n")
					fh1.write("		I2 => prod4(2),\n")
					fh1.write("		I3 => prod2(7),\n")
					fh1.write("		I4 => prod3(7),\n")
					fh1.write("		I5 => prod4(3),\n")
					fh1.write("		O5 => gen(3),\n")
					fh1.write("		O6 => prop(3)\n")
					fh1.write("		);\n")
					fh1.write("\n")
					fh1.write("--PROD(10) <= prop(3);\n")
					fh1.write("PROD(11) <= prop(3);\n")
					fh1.write("\n")

					#	Functionality of INIT value FFFFFFE8FFE8E800 is :
					#	We compute the carry from I0+I1+I2 and add it to the result of I3+I4+I5
					#	Output O6 is the MSB of this result (carry out)
					#	Boolean expression : O6 = I3.I4 + I4.I5 + I3.I5 + I3.(I0.I1 + I1.I2 + I0.I2) + I4.(I0.I1 + I1.I2 + I0.I2) + I5.(I0.I1 + I1.I2 + I0.I2)

					fh1.write("lut_inst4: lut6_2\n")
					fh1.write("		generic map(INIT => X\"FFFFFFE8FFE8E800\")\n")
					fh1.write("		port map(\n")
					fh1.write("		I0 => prod2(6),\n")
					fh1.write("		I1 => prod3(6),\n")
					fh1.write("		I2 => prod4(2),\n")
					fh1.write("		I3 => prod2(7),\n")
					fh1.write("		I4 => prod3(7),\n")
					fh1.write("		I5 => prod4(3),\n")
					fh1.write("		--O5 => temp,\n")
					fh1.write("		O6 => temp\n")
					fh1.write("		);\n")
					fh1.write("\n")

					#	Functionality of INIT value 6666666678787878 is :
					#	Boolean expression : O5 = I2 xor (I1.I0)
					#	Boolean expression : O6 = I0 xor I1

					fh1.write("lut_inst5: lut6_2\n")
					fh1.write("		generic map(INIT => X\"6666666678787878\")\n")
					fh1.write("		port map(\n")
					fh1.write("		I0 => temp,\n")
					fh1.write("		I1 => prod4(4),\n")
					fh1.write("		I2 => prod4(5),\n")
					fh1.write("		I3 => '1',\n")
					fh1.write("		I4 => '1',\n")
					fh1.write("		I5 => '1',\n")
					fh1.write("		O5 => gen(4),\n")
					fh1.write("		O6 => prop(4)\n")
					fh1.write("		);\n")
					fh1.write("\n")
					fh1.write("PROD(12) <= prop(4);\n")
					fh1.write("PROD(13) <= gen(4);\n")
					fh1.write("\n")

					#	Functionality of INIT value 7F807F807FFF8000 is :
					#	Boolean expression : O5 = I4 xor (I3.I2.I1.I0)
					#	Boolean expression : O6 = I3 xor (I0.I1.I2)

					fh1.write("lut_inst6: lut6_2\n")
					fh1.write("		generic map(INIT => X\"7F807F807FFF8000\")\n")
					fh1.write("		port map(\n")
					fh1.write("		I0 => temp,\n")
					fh1.write("		I1 => prod4(4),\n")
					fh1.write("		I2 => prod4(5),\n")
					fh1.write("		I3 => prod4(6),\n")
					fh1.write("		I4 => prod4(7),\n")
					fh1.write("		I5 => '1',\n")
					fh1.write("		O5 => gen(5),\n")
					fh1.write("		O6 => prop(5)\n")
					fh1.write("		);\n")
					fh1.write("\n")
					fh1.write("PROD(14) <= prop(5);\n")
					fh1.write("PROD(15) <= gen(5);\n")
					fh1.write("\n")
					fh1.write("end Behavioral;")

				with open("tb_mult_%s.vhd" % s, "w") as fh2: 	
					fh2.write("library IEEE;\n")
					fh2.write("use IEEE.STD_LOGIC_1164.ALL;\n")
					fh2.write("use IEEE.NUMERIC_STD.ALL;\n")
					fh2.write("library UNISIM;\n")
					fh2.write("use UNISIM.VComponents.all;\n")
					fh2.write("use std.textio.all;\n")
					fh2.write("use work.all;\n")
					fh2.write("use work.str_to_stdvec_helpers.all;\n")
					fh2.write("\n")
					fh2.write("entity tb_mult_" + s + " is\n")
					fh2.write("end tb_mult_" + s + ";\n")
					fh2.write("\n")
					fh2.write("architecture Behavioral of tb_mult_" + s + " is\n")
					fh2.write("component mult_mod_8_" + s +" is\n")
					fh2.write("		Port ( A : in  STD_LOGIC_VECTOR (7 downto 0);\n")
					fh2.write("			   B : in  STD_LOGIC_VECTOR (7 downto 0);\n")
					fh2.write("			   PROD : out  STD_LOGIC_VECTOR (15 downto 0));\n")
					fh2.write("end component;\n")
					fh2.write("signal a_sig, b_sig: STD_LOGIC_VECTOR (7 downto 0) :=(others => '0');\n")
					fh2.write("signal prod_sig: STD_LOGIC_VECTOR (15 downto 0);\n")
					fh2.write("\n")
					fh2.write("begin\n")
					fh2.write("inst1_mult: mult_mod_8_" + s +" port map(\n")
					fh2.write("A => a_sig,\n")
					fh2.write("B => b_sig,\n")
					fh2.write("PROD => prod_sig\n")
					fh2.write(");\n")
					fh2.write("stim: process\n")
					fh2.write("\n")
					fh2.write("		file output_file : text;\n")
					fh2.write("		variable str_stimulus_out : string(16 downto 1);\n")
					fh2.write("		variable file_line_out : line;\n")
					fh2.write("begin\n")
					fh2.write("		file_open(output_file, \"mult_8x8_" + s + ".txt\", WRITE_MODE);\n")
					fh2.write("		for j in 0 to 255 loop\n")
					fh2.write("			for i in 0 to 255 loop\n")
					fh2.write("				a_sig <= std_logic_vector(to_unsigned(i, 8));\n")
					fh2.write("				b_sig <= std_logic_vector(to_unsigned(j, 8));\n")
					fh2.write("				wait for 1 ns;\n")
					fh2.write("				str_stimulus_out := stdvec_to_str(prod_sig);\n")
					fh2.write("				write(file_line_out, str_stimulus_out);\n")
					fh2.write("				writeline(output_file, file_line_out);\n")
					fh2.write("			end loop;\n")
					fh2.write("		end loop;\n")
					fh2.write("		wait;\n")
					fh2.write("		file_close(output_file);\n")
					fh2.write("end process;\n")
					fh2.write("\n")
					fh2.write("end Behavioral;\n")







